﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ShipController : MonoBehaviour
{
    // Start is called before the first frame update

    void Start()
    {
        rb = GetComponent<Rigidbody2D>();    
    }
    
    // Cached Rigidbody2D reference
    Rigidbody2D rb;

    [Header("Input")]
    // Input Map
    public string HorizontalInput = "Horizontal";
    public string VerticalInput = "Vertical";
    public string FireCannonsButton = "Fire1";
    public bool ControlsEnabled = true;

    [Header("Movement")]
    // Movement Variables 
    public float shipSpeed = 10;
    public float shipTurnSpeed = 180;        
    float movement;
    float turn;

    // Simple Fire Control System
    [Header("Fire Control")]
    // when the last time the ship fired
    public float NextFire = 0f;
    public float FireDelay = 2;
    public Transform CannonballPrefab;
    public Transform[] GunPorts;


    void FixedUpdate()
    {
        if (ControlsEnabled)
        {
            movement = Input.GetAxis(VerticalInput);
            turn = Input.GetAxis(HorizontalInput);  
            
            if (Input.GetButtonDown(FireCannonsButton))
            {
                FireCannons();
            }
        }
        else
        {
            movement = 0f;
            turn = 0f;
        }
        Vector3 delta = movement * shipSpeed * transform.up * Time.fixedDeltaTime;
        rb.MovePosition(rb.position + (Vector2)delta);
        rb.MoveRotation(rb.rotation + turn * shipTurnSpeed * Time.fixedDeltaTime * -1);
    }

    void FireCannons()
    {
        if (Time.time > NextFire)
        {
            foreach (Transform port in GunPorts)
            {
                Transform o = Instantiate(CannonballPrefab, port.position, port.rotation, null);
            }
            NextFire = Time.time + FireDelay;
        }
    }

}

